LeetCode 加油站

hestyle發表於2019-02-23

在一條環路上有 N 個加油站,其中第 i 個加油站有汽油 gas[i] 升。
你有一輛油箱容量無限的的汽車,從第 i 個加油站開往第 i+1 個加油站需要消耗汽油 cost[i] 升。你從其中的一個加油站出發,開始時油箱為空。
如果你可以繞環路行駛一週,則返回出發時加油站的編號,否則返回 -1。

說明:

如果題目有解,該答案即為唯一答案。
輸入陣列均為非空陣列,且長度相同。
輸入陣列中的元素均為非負數。

示例 1:

輸入: 
gas  = [1,2,3,4,5]
cost = [3,4,5,1,2]
輸出: 3
解釋:
從 3 號加油站(索引為 3 處)出發,可獲得 4 升汽油。此時油箱有 = 0 + 4 = 4 升汽油
開往 4 號加油站,此時油箱有 4 - 1 + 5 = 8 升汽油
開往 0 號加油站,此時油箱有 8 - 2 + 1 = 7 升汽油
開往 1 號加油站,此時油箱有 7 - 3 + 2 = 6 升汽油
開往 2 號加油站,此時油箱有 6 - 4 + 3 = 5 升汽油
開往 3 號加油站,你需要消耗 5 升汽油,正好足夠你返回到 3 號加油站。
因此,3 可為起始索引。

示例 2:

輸入: 
gas  = [2,3,4]
cost = [3,4,3]
輸出: -1
解釋:
你不能從 0 號或 1 號加油站出發,因為沒有足夠的汽油可以讓你行駛到下一個加油站。
我們從 2 號加油站出發,可以獲得 4 升汽油。 此時油箱有 = 0 + 4 = 4 升汽油
開往 0 號加油站,此時油箱有 4 - 3 + 2 = 3 升汽油
開往 1 號加油站,此時油箱有 3 - 3 + 3 = 3 升汽油
你無法返回 2 號加油站,因為返程需要消耗 4 升汽油,但是你的油箱只有 3 升汽油。
因此,無論怎樣,你都不可能繞環路行駛一週。

思路分析:採取回溯法。最開始選擇出發點,如果在當前節點剩餘的油能夠走到下一個節點,就繼續往下走,直到回到出發點,否則改變出發點,繼續尋找。

class Solution {
public:
	int result = -1;
	int canCompleteCircuit(vector<int>& gas, vector<int>& cost) {
		int vecSize = gas.size();
		//選擇出發點(不包括最後一個點)
		for (int i = 0; i < vecSize - 1; ++i) {
			if (gas[i] >= cost[i] && dfs(gas, cost, i, i + 1, gas[i] - cost[i])) {
				return result;
			}
		}
        //單獨最後一個點作為出發點,因為最後一個點出發點的下一個點是下標0
		if (gas[vecSize - 1] >= cost[vecSize - 1]) {
			dfs(gas, cost, vecSize - 1, 0, gas[vecSize - 1] - cost[vecSize - 1]);
		}
		return result;
	}
	//beginIndex是出發點, nowIndex現在的下標, remainGas走到nowIndex剩餘的汽油, 現在剩餘的汽油需要加上gas[nowIndex]
	bool dfs(vector<int>& gas, vector<int>& cost, int beginIndex, int nowIndex, int remainGas) {
		if (beginIndex == nowIndex) {//如果回到的出發點
			result = beginIndex;
			return true;
		}
		int vecSize = gas.size();
		if (remainGas + gas[nowIndex] >= cost[nowIndex]) {//判斷能否繼續往下走
			if (nowIndex == vecSize - 1) {//如果現在處於尾端,下一個位置是0
				return dfs(gas, cost, beginIndex, 0, remainGas - cost[nowIndex] + gas[nowIndex]);
			}
			else {//否則直接移動到下一個下標
				return dfs(gas, cost, beginIndex, nowIndex + 1, remainGas - cost[nowIndex] + gas[nowIndex]);
			}
		}
		return false;
	}
};

在這裡插入圖片描述
方法二:遞推法。窮舉出發點,直接遞推往下走

class Solution {
public:
	int canCompleteCircuit(vector<int>& gas, vector<int>& cost) {
		int vecSize = gas.size();
		int remainGas;
		//選擇出發點
		for (int begin = 0; begin < vecSize; ++begin) {
			int nowIndex = begin;
			//如果這個點能夠出發
			if (gas[begin] < cost[begin]) {
				continue;
			}
			//出發
			remainGas = gas[begin] - cost[begin];
			nowIndex = (nowIndex + 1) % vecSize;//迴圈後移
			//如果能夠往下走
			while (gas[nowIndex] + remainGas >= cost[nowIndex] && nowIndex != begin) {
				remainGas += gas[nowIndex] - cost[nowIndex];//更新剩餘的油
				nowIndex = (nowIndex + 1) % vecSize;//迴圈後移
			}
			if (nowIndex == begin) {
				return begin;
			}
		}
		return -1;
	}
};

在這裡插入圖片描述

相關文章